package nl.tue.id.zoo.animal;

import nl.tue.id.zoo.util.*;
import nl.tue.id.zoo.food.Food;
import nl.tue.id.zoo.ui.Body;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
abstract public class Animal implements LifeHolder {
    private Life life;
    private double weight;
    private Body body;

    public Animal() {
        birth();
    }

    private void birth() {
        life = new Life(this);
        setBody();
        setBirthWeight();
    }

    protected void setBody(){
        this.body = new Body(this);
    }

    public long getAge() {
        return life.howOldAreYou();
    }

    abstract public void move();

    abstract public void eat(Food food);

    public void say(String words){
        System.out.println(words);
    }


    protected void setWeight(double weight) {
        this.weight = weight;
        this.body.grow((int) weight);
    }

    public double getWeight() {
        return weight;
    }

    protected void setBirthWeight() {
        setWeight(0);
    }


    public void LifeGoesOn() {
        //   say("Happily living animal.");
        if (body != null) {
            if (body.getTitle().length()==0) {
                if (this instanceof Pet) {
                    body.setTitle(((Pet)this).getName());
                }
            }
        }
    }

    public void Sleep() {
        say("Sleeping now");
    }

    public void Getup() {
        say("Getting up now.");
    }

    public void Birthday() {
        beHappy();
        say("Happy birthday to me, I am now " +
                getAge() + " year old, " +
                getWeight() + "kilo big.");
    }

    protected void beHappy() {
        move();
        say(null);
        move();
        say(null);
        move();
        say(null);
    }

    public void sayGoodBye() {
        say("That was it, Amen...");
    }
}
