package nl.tue.id.zoo.ui;

import java.awt.*;

import javax.swing.*;
import java.awt.Dimension;
import java.awt.BorderLayout;
import nl.tue.id.zoo.animal.Animal;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import nl.tue.id.zoo.util.Pet;
import java.awt.event.MouseEvent;
import java.awt.event.MouseAdapter;
import java.util.Random;

/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class Body extends JFrame {
    BorderLayout borderLayout1 = new BorderLayout();
    JButton mouth = new JButton();
    Animal animal = null;

    private Body() {
        try {
            jbInit();
            this.setVisible(true);
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    public Body(Animal animal){
        this();
        this.animal = animal;
        if(animal instanceof Pet){
            mouth.setEnabled(true);
        }
    }


    private void jbInit() throws Exception {
        Random r= new Random();
        this.setSize(new Dimension(400, 227));
        this.addMouseListener(new Body_this_mouseAdapter(this));

        getContentPane().setLayout(borderLayout1);

        this.setLocation(r.nextInt(300),r.nextInt(300));
        mouth.setEnabled(false);

        mouth.setText("Mouth");
        mouth.addActionListener(new Body_mouth_actionAdapter(this));
        this.getContentPane().add(mouth, java.awt.BorderLayout.SOUTH);


    }

    public void mouth_actionPerformed(ActionEvent e) {
        animal.eat(BuffetTable.getTheTable().whatHasBeenChoosen());

    }

    public void grow(int weight){
        this.setSize(this.getSize().width + weight,
                this.getSize().height + weight);
        this.validate();
    }

    public void this_mousePressed(MouseEvent e) {
        if(animal instanceof Pet) ((Pet) animal).play();
    }


}


class Body_this_mouseAdapter extends MouseAdapter {
    private Body adaptee;
    Body_this_mouseAdapter(Body adaptee) {
        this.adaptee = adaptee;
    }

    public void mousePressed(MouseEvent e) {
        adaptee.this_mousePressed(e);
    }
}


class Body_mouth_actionAdapter implements ActionListener {
    private Body adaptee;
    Body_mouth_actionAdapter(Body adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.mouth_actionPerformed(e);
    }
}
